<?php

namespace Pepitelabs\PWS\PickUpService;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPickUpDetail PickUpService
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPickUpDetail
 * @subpackage Arrays
 */
class ArrayOfPickUpDetail extends AbstractStructArrayBase
{
    /**
     * The PickUpDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pepitelabs\PWS\PickUpService\PickUpDetail[]
     */
    public $PickUpDetail;
    /**
     * Constructor method for ArrayOfPickUpDetail
     * @uses ArrayOfPickUpDetail::setPickUpDetail()
     * @param \Pepitelabs\PWS\PickUpService\PickUpDetail[] $pickUpDetail
     */
    public function __construct(array $pickUpDetail = array())
    {
        $this
            ->setPickUpDetail($pickUpDetail);
    }
    /**
     * Get PickUpDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pepitelabs\PWS\PickUpService\PickUpDetail[]|null
     */
    public function getPickUpDetail()
    {
        return isset($this->PickUpDetail) ? $this->PickUpDetail : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPickUpDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPickUpDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePickUpDetailForArrayConstraintsFromSetPickUpDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPickUpDetailPickUpDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfPickUpDetailPickUpDetailItem instanceof \Pepitelabs\PWS\PickUpService\PickUpDetail) {
                $invalidValues[] = is_object($arrayOfPickUpDetailPickUpDetailItem) ? get_class($arrayOfPickUpDetailPickUpDetailItem) : sprintf('%s(%s)', gettype($arrayOfPickUpDetailPickUpDetailItem), var_export($arrayOfPickUpDetailPickUpDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PickUpDetail property can only contain items of type \Pepitelabs\PWS\PickUpService\PickUpDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PickUpDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pepitelabs\PWS\PickUpService\PickUpDetail[] $pickUpDetail
     * @return \Pepitelabs\PWS\PickUpService\ArrayOfPickUpDetail
     */
    public function setPickUpDetail(array $pickUpDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($pickUpDetailArrayErrorMessage = self::validatePickUpDetailForArrayConstraintsFromSetPickUpDetail($pickUpDetail))) {
            throw new \InvalidArgumentException($pickUpDetailArrayErrorMessage, __LINE__);
        }
        if (is_null($pickUpDetail) || (is_array($pickUpDetail) && empty($pickUpDetail))) {
            unset($this->PickUpDetail);
        } else {
            $this->PickUpDetail = $pickUpDetail;
        }
        return $this;
    }
    /**
     * Add item to PickUpDetail value
     * @throws \InvalidArgumentException
     * @param \Pepitelabs\PWS\PickUpService\PickUpDetail $item
     * @return \Pepitelabs\PWS\PickUpService\ArrayOfPickUpDetail
     */
    public function addToPickUpDetail(\Pepitelabs\PWS\PickUpService\PickUpDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pepitelabs\PWS\PickUpService\PickUpDetail) {
            throw new \InvalidArgumentException(sprintf('The PickUpDetail property can only contain items of type \Pepitelabs\PWS\PickUpService\PickUpDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PickUpDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pepitelabs\PWS\PickUpService\PickUpDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pepitelabs\PWS\PickUpService\PickUpDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pepitelabs\PWS\PickUpService\PickUpDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pepitelabs\PWS\PickUpService\PickUpDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pepitelabs\PWS\PickUpService\PickUpDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PickUpDetail
     */
    public function getAttributeName()
    {
        return 'PickUpDetail';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pepitelabs\PWS\PickUpService\ArrayOfPickUpDetail
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
